
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

enum { NONE = 0, PLUS, MINUS};
void set_ndl(char *s, int n, char *err);

int NW = 0, W[20]={0};

static XS(perl_ActiveNodelist)
{
    dXSARGS;
    STRLEN n_a;
    char *s, j[256];
    char *err="perl_ActiveNodelist()";
    int i, n;
	
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }

    sp_s = FromSP(0);	
    s = XCAL;
    strncpy(s, sp_s, n_a);
    strip(s);
    expand_str(s);
	
    if (!strlen(s)) {
	fprintf(stderr, "%s syntax `%s'\n", err, s);
	abort();
    }

    set_ndl(s, 9, err);
    set_ndl(s, 0, err);

    for( i = 0; i < NW; ++i) {
	if (W[i] == 0) {
	    for( n = 0; n < i+1; ++n) get_next_word(s, j);
	    
	    {
		fprintf(stderr, "%s nodelist or v9 block undefined : `%s'\n", err, j);
		abort();
	    }
	}
    }

/*
	for( ndlTag = v9_ndlTagFirst; ndlTag; ndlTag = ndlTag->next )
		if (ndlTag->active)
			printf("%s\n", ndlTag->tag);
	
	for( ndlTag = ndlTagFirst; ndlTag; ndlTag = ndlTag->next )
		if (ndlTag->active)
			printf("%s\n", ndlTag->tag);
*/

    free(s);
    
    XSRETURN_UNDEF;
	
}
/***************************/
void set_ndl(char *s, int n, char *err)
{
	char *ptag, w[256], save[256];
	struct ndlTags *ndlTag = NULL;
	int opt;
	int nw = -1;

err[0]=0;
	if (n == 9)
		ndlTag = v9_ndlTagFirst;
	else
		ndlTag = ndlTagFirst;

	for( ; ndlTag; ndlTag = ndlTag->next )
	{
		strcpy(save, s);
		nw = 0;
		while (get_next_word(save, w))
		{
			ptag = w;
			if (*ptag == '+') {
				++ptag;
				opt = PLUS;
			}
			else if (*ptag == '-') {
				++ptag;
				opt = MINUS;
			}
			else
				opt = NONE;

			if (!stricmp(ndlTag->tag, ptag)) {
				if (opt == MINUS)
					ndlTag->active = No;
				else
					ndlTag->active = Yes;
				W[nw++] = 1;
				break;
			}
			else if (opt == NONE)
				ndlTag->active = No;
			
			++nw;

		} /*  next word */
		
	}   /*  ndlTag    */

	if (nw > NW)
		NW = nw;

	return;
}
