
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_AddIntl)
{
    dXSARGS;
    char *err="perl_AddIntl()";
    char cFrom[64], cTo[64];
    ADDR tmpAddr;
    TEXT *textbuf = NULL;

    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
	
    if (ftn.stat & i_Intl) {
	writeToLog(3, "%s INTL already present (the attr set)\n", err);
	XSRETURN_UNDEF;
    }
	
    for (textbuf = TextFirst; textbuf; textbuf = textbuf->next) {
	if (!strnicmp(textbuf->str, "\1INTL", 5)) {
	    writeToLog(3, "%s error: INTL already present but the attribute NOT set ???\n",
				err);
	    XSRETURN_UNDEF;
	}
    }
	
    tmpAddr = ftn.from;
    tmpAddr.point = 0;
    addr_to_str( tmpAddr, cFrom);
    tmpAddr = ftn.to;
    tmpAddr.point = 0;
    addr_to_str( tmpAddr, cTo);
	
    textbuf = (TEXT *) calloc(1, sizeof(TEXT) );
    textbuf->next = NULL;

    sprintf(textbuf->str, "\1INTL %s %s\r", cTo, cFrom);
    (void) add_text(&TextFirst, textbuf, 1, Mode_Bin);
    free_text(textbuf);

	
    log_msg_hdr();
    writeToLog(1, "   INTL added");
	
    XSRETURN_UNDEF;	
}

