
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_GetHdr)
{
/* return: @array			$array[0] = fromName
					$array[1] = fromAddr
					$array[2] = toName
					$array[3] = toAddr
					$array[4] = subject
					$array[5] = date&time
					$array[6] = attr (string)
*/
    dXSARGS;
    char *prehdr[7], *err="perl_GetHdr()";
    char cattr[128], cflag[128], cstat[128], buf[256];
    int hdr;
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
/*///////////////////////////////////////////////////////////////////////*/
																			/* Initialize data area       */

    
    if (*ftn.fromName) {
	hdr = strlen(ftn.fromName);
	prehdr[0] = (char*)xcalloc(hdr+1, sizeof(char));
	strcpy(prehdr[0], ftn.fromName);
    } else {
	prehdr[0] = (char*)xcalloc(1, sizeof(char));
    }
    
    addr_to_str(ftn.from , buf);
    if (*buf) {
	hdr = strlen(buf);
	prehdr[1] = (char*)xcalloc(hdr+1, sizeof(char));
	strcpy(prehdr[1], buf);
    } else {
	prehdr[1] = (char*)xcalloc(1, sizeof(char));
    }
    
    if (*ftn.toName) {
	hdr = strlen(ftn.toName);
	prehdr[2] = (char*)xcalloc(hdr+1, sizeof(char));
	strcpy(prehdr[2], ftn.toName);
    } else {
	prehdr[2] = (char*)xcalloc(1, sizeof(char));
    }

    addr_to_str( ftn.to , buf );
    if (*buf) {
	hdr = strlen(buf);
	prehdr[3] = (char*)xcalloc(hdr+1, sizeof(char));
	strcpy(prehdr[3], buf);
    } else {
	prehdr[3] = (char*)xcalloc(1, sizeof(char));
    }
    
    if (*ftn.subject) {
	hdr = strlen(ftn.subject);
	prehdr[4] = (char*)xcalloc(hdr+1, sizeof(char));
	strcpy(prehdr[4], ftn.subject);
    } else {
	prehdr[4] = (char*)xcalloc(1, sizeof(char));
    }

    if (*ftn.DateTime) {
	hdr = strlen(ftn.DateTime);
	prehdr[5] = (char*)xcalloc(hdr+1, sizeof(char));
	strcpy(prehdr[5], ftn.DateTime);
    } else {
	prehdr[5] = (char*)xcalloc(1, sizeof(char));
    }
    
    /*/////////////////////////////////*/
    attr_to_str( ftn.attr ,  cattr );
    flag_to_str( ftn.flag, cflag );
    stat_to_str( ftn.stat, cstat );
    /*/////////////////////////////////*/
    sprintf( buf , "%s %s %s", cattr, cflag, cstat );
    if (*buf) {
	hdr = strlen(buf);
	prehdr[6] = (char*)xcalloc(hdr+1, sizeof(char));
	strcpy(prehdr[6], buf);
    } else {
	prehdr[6] = (char*)xcalloc(1, sizeof(char));
    }
    
    EXTEND(SP, 7);
    for (hdr = 0; hdr < 7; hdr++) {
	ST(hdr) = sv_newmortal();
	sv_setpv((SV*)ST(hdr), prehdr[hdr]);
	free(prehdr[hdr]);
    }
    free(prehdr);
    XSRETURN(hdr);
}

