
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


char **getmsg (int *ptotal, BOOL raw)
{
    char **lines = NULL;
    TEXT* tmp;
    
    for (*ptotal = 0, tmp = TextFirst; tmp; tmp = tmp->next, (*ptotal)++) {
	if (*ptotal == 0) {
	    lines = (char**)xmalloc(sizeof(char*));
	} else {
	    lines = (char**)xrealloc(lines, (*ptotal + 1)*sizeof(char*));
	}
	lines[*ptotal] = (char*)xcalloc(strlen(tmp->str)+1, sizeof(char));
	strcpy(lines[*ptotal], tmp->str);
	if (!raw) {
	    if (is_kludge(lines[*ptotal])) *(lines[*ptotal]) = '@';
	}
		
	strip_CRLF(lines[*ptotal]);
		
    }
    return lines;
}

static XS(perl_GetMsg)
{
    dXSARGS;
    char *err = "perl_GetMsg()";
    char **lines;
    int total, l;
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }

    lines = getmsg (&total, 0);

    if (total) {
	EXTEND(SP, total);
    
        for (l = 0; l < total; l++) {
	    ST(l) = sv_newmortal();
	    sv_setpv((SV*)ST(l), lines[l]);
	    free(lines[l]);
	}
	
	free(lines);
	XSRETURN(l);
    }
    XSRETURN_UNDEF;	
	
}

static XS(perl_GetRawMsg)
{
    dXSARGS;
    char **lines, *err="perl_GetRawMsg()";
    int total, l;
    
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }

    lines = getmsg (&total, 1);
	
    if (total) {
	EXTEND(SP, total);
    
        for (l = 0; l < total; l++) {
	    ST(l) = sv_newmortal();
	    sv_setpv((SV*)ST(l), lines[l]);
	    free(lines[l]);
	}
	
	free(lines);
	XSRETURN(l);
    }
    XSRETURN_UNDEF;	

}
