
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static int shTot;

static XS(perl_GetNodelistBlock)
{
    dXSARGS;
    STRLEN n_a;
    char *block_name;
    char **prenblock;
    char *err = "perl_GetNedelistBlock()";
    int nblock, count;


    if (items > 1) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
    
    
    block_name = (char*)xcalloc(1, sizeof(char));
    
    if (items) {

	sp_s = FromSP(0);
	block_name = (char*)xrealloc(block_name, (n_a+1)*sizeof(char));
	strncpy(block_name, sp_s, n_a);
	block_name[n_a] = '\0';
	strip(block_name);
	expand_str(block_name);

    }

    shTot = 0;

    prenblock = NULL;
    count = 0;
	
    get_ndl (ndlTagFirst, block_name, &prenblock, &count);
    get_ndl (v9_ndlTagFirst, block_name, &prenblock, &count);

    if (count) {
	EXTEND(SP, count);
    
        for (nblock = 0; nblock < count; nblock++) {
	    ST(nblock) = sv_newmortal();
	    sv_setpv((SV*)ST(nblock), prenblock[nblock]);
	    free(prenblock[nblock]);
	}
	
	free(prenblock);
	XSRETURN(nblock);
    }


    XSRETURN_UNDEF;	
}

void get_ndl (struct ndlTags* ndlTag, char* block_name, char ***prenblock, int *count)
{

    char **nblock;
    
    nblock = *prenblock;

    for(; ndlTag; ndlTag = ndlTag->next ) {
	if (strlen(block_name) && stricmp(ndlTag->tag, block_name))
	    continue;
	else {
	    struct nodelist* ndl;
	    char *row, *nn[10], allnames[256], buf[256];
	    int n, cnt;
	
	    for (ndl = ndlTag->recfirst; ndl; ndl=ndl->next) {
		sprintf (buf, "%s %hu %hu %s", ndl->ext, ndl->zone, ndl->reg, ndl->path);
		row = (char*)xstrcpy (buf);
		strcpy(allnames, ndl->allnames);
		cnt = getndlnames(ndl->path, allnames, nn);
		for (n = 0; n < cnt; ++n) {
		    row = (char*)xstrcat (row, " ");
		    row = (char*)xstrcat (row, nn[n]);
		}
		
		if (*count) {
		    nblock = (char**)xrealloc(nblock, (*count+1)*sizeof(char*));
		} else {
		    nblock = (char**)xmalloc((*count+1)*sizeof(char*));
		}
		nblock[*count] = row;
		*prenblock = nblock;
		(*count)++;
	    }
		
	    if (strlen(block_name)) break;
	}
    }
}
