
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_GetText)
{
    dXSARGS;
    TEXT *txt;
    int count, text;
    char *line = NULL, **pretext = NULL, *err="perl_GetText()";
    
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
    for( count = 0, txt = TextFirst; txt; txt = txt->next) {
/*	size_t l; */

	if (txt->str[0] == '\0') continue;
		
	if (txt->str[strlen(txt->str)-1] != '\r' && txt->str[strlen(txt->str)-1] != '\n') continue;
		
/*  if (is_kludge(line) || is_TearLine(line) || is_Origin(line) ) { */
		
	if (is_kludge(txt->str)) {
/*	    free (line); */
/*	    line = NULL; */
	    continue;
	}
		
	if (line == NULL) {
	    line = (char *)xcalloc(strlen(txt->str)+1, sizeof(char));
	    strcpy (line, txt->str);
	} else {
	    line = (char *)xrealloc(line, strlen(line) + strlen(txt->str) + 1);
	    strcat (line, txt->str);
	}
	strip_CRLF(line);
		
	if (count) {
	    pretext = (char**)xrealloc(pretext, (count+1)*sizeof(char*));
	} else {
	    pretext = (char**)xmalloc((count+1)*sizeof(char*));
	}	
	
	pretext[count] = (char*)xcalloc(strlen(line)+1, sizeof(char));
	
	strcpy(pretext[count], line);
	
	free (line);
	line = NULL;
	count++;
    } /* text loop */
	
    if (count) {
	EXTEND(SP, count);
    
        for (text = 0; text < count; text++) {
	    ST(text) = sv_newmortal();
	    sv_setpv((SV*)ST(text), pretext[text]);
	    free(pretext[text]);
	}
	
	free(pretext);
	XSRETURN(text);
    }
																		/* set stem.0 to lines read   */
    XSRETURN_UNDEF;
}

