
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_GetUplink)
{
/* call: GetUplink( "Address" ) */

    dXSARGS;
    STRLEN n_a;	
    char addr_str[128], *caddr, *err="perl_GetUplink";
    word uplink = 0, region = 0;
    ADDR addr;
	
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }

    sp_s = FromSP(0);
    caddr = XCAL;
    strncpy(caddr, sp_s, n_a);
    strip(caddr);
    expand_str(caddr);
	
    if ( !str_to_addr(caddr , &addr) ) {
	fprintf(stderr, "%s incorrect address : `%s'\n", err, caddr);
	abort();
    }
	
    free(caddr);
    
    if (get_ndl_info(addr, &uplink, &region)) {
	addr.node = uplink;
	addr.point = 0;
	addr_to_str(addr, addr_str);
	XSRETURN_PV(addr_str);
    }
    XSRETURN_UNDEF;
}
