
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_GetVias)
{
    dXSARGS;
    char buf[256], **previas, *err="perl_GetVias()";
    TEXT *txt;
    int count, vias;
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
/*///////////////////////////////////////////////////////////////////////*/
		
    previas = NULL;																	/* Initialize data area       */
    for(count = 0, txt = ViaTextFirst; txt; txt = txt->next) {
	strcpy( buf, &txt->str[5]);

	strip_CRLF(buf);
		
	if (strlen(buf)) {
	    if (previas) {
		previas = (char**)xrealloc(previas, (count+1)*sizeof(char*));
	    } else {
		previas = (char**)xmalloc((count+1)*sizeof(char*));
	    }
	    previas[count] = (char*)xcalloc(strlen(buf)+1, sizeof(char));
	    strcpy(previas[count], buf);
	    memset(&buf, '\0', 256);
	    count++;
	}
    } /* text loop */

    if (count) {
	EXTEND(SP, count);
	
	for (vias = 0; vias < count; vias++) {
	    ST(vias) = sv_newmortal();
	    sv_setpv((SV*)ST(vias), previas[vias]);
	    free(previas[vias]);
	}
	free(previas);
	
	XSRETURN(vias);
    }	
																		/* set stem.0 to lines read   */
    XSRETURN_UNDEF;
}

