$file = '../whatsnew';
$fileh= '../include/date.h';
$perlcmd= 'perl -v';

%mon = ("Jan", 1,
	"Feb", 2,
	"Mar", 3,
	"Apr", 4,
	"May", 5,
	"Jun", 6,
	"Jul", 7,
	"Aug", 8,
	"Sep", 9,
	"Oct",10,
	"Nov",11,
	"Dec",12);
 
	

open(F, "<$file") or die "Unable to open file '$file': (".int($!).") $!\n";

$found = 0;
while (<F>) {
    last if ($found = s/[a-z]{3} +([a-z]{3}) +([0-9]+) +[0-9]{2}:[0-9]{2}:[0-9]{2} +[a-z]+ +([0-9]+)\r?$/\2 \1 \3/i);
}
close(F);

die "Unable to extract date from file '$file'\n" if !$found;

($mday, $mon, $year) = split;

open(F, "$perlcmd|") or die "Unable to get perl version ('$perlcmd'): (".int($!).") $!\n";

$found = 0;
while (<F>) {
    chomp;
    last if ($found = s/this is perl, (.*)$/\1/i);
}
close(F);

die "Unable to extract perl version from '$perlcmd'\n" if !$found;

$perl_ver = $_;

open (F, ">$fileh") or die "Can't write to file '$fileh': (".int($!).") $!\n";

printf(F "char itraxp_date[]=\"%02d-%02d-%s\";\n", $mday, $mon{$mon}, substr($year, 2, 2));
printf(F "char perl_ver[]=\"%s\";\n", $perl_ver);

close(F);

