
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/* defined in deffage.c*/
dword get_age(char *cage);

void defMsgAge(char *tag, char *str, char *err_diag)
{
/* call: (" DAYS[:MINS] , [addr]) */
	
	struct MsgAgeTags *MsgAgeTag = NULL, *mark = NULL;
	char buf[256], cage[10], caddr[128];
	ADDR addr;
	dword secs = 0L;

	/* TAG */
	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	addr.zone = addr.net = addr.node = addr.point = Wild_1;
	
	/* AGE as DAYS[:MINS] */
	get_next_word(str, cage);
	cage[9] = 0;

	if ((dword)-1L == (secs = get_age(cage))) {
		sprintf(buf, "%s syntax in age : `%s' -- should be days:mins",
						err_diag, cage);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag( (int) MESSAGEAGE, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	

	/* ADDR */
	if (get_next_word(str, caddr)) {
		
		caddr[127] = 0;

		if ( !str_to_Waddr(caddr, &addr) ) {
			sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( MsgAgeTag = MsgAgeTagFirst; MsgAgeTag; MsgAgeTag = MsgAgeTag->next )
	{
		if (!stricmp(tag, MsgAgeTag->tag)) {
			mark = MsgAgeTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		MsgAgeTag = mark;
	}
	else {    /* create new tag */
		MsgAgeTag = (struct MsgAgeTags *)calloc(1, sizeof(struct MsgAgeTags));
		MsgAgeTag->next  = NULL;
		/*//////////////////////*/
		strcpy(MsgAgeTag->tag, tag);
		/*//////////////////////*/
		MsgAgeTag->rec = MsgAgeTag->recfirst = MsgAgeTag->reclast  = NULL;
		
		if (MsgAgeTagLast) {
			MsgAgeTagLast->next = MsgAgeTag;
		}
		else {
			MsgAgeTagFirst = MsgAgeTag;
		}
		
		MsgAgeTagLast = MsgAgeTag;
	}
	
	MsgAgeTag->rec = (struct MsgAge *)calloc(1, sizeof(struct MsgAge));
	MsgAgeTag->rec->next = NULL;
	/*//////////////////////*/
	MsgAgeTag->rec->secs = secs;
	MsgAgeTag->rec->addr = addr;
	/*//////////////////////*/
	
	if (MsgAgeTag->reclast) {
		MsgAgeTag->reclast->next = MsgAgeTag->rec;
	}
	else {
		MsgAgeTag->recfirst = MsgAgeTag->rec;
	}
	
	MsgAgeTag->reclast = MsgAgeTag->rec;

	
	return;
}
