
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <dir.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>

#define Ok 1
#define Fail 0

typedef unsigned short word;
typedef unsigned long dword;
typedef word BOOL;

void  unix_to_ftscdate(time_t t, char *s);
dword fdate_to_unix(word *ftime, word *fdate);

struct dos_d
{
	word da : 5;
	word mo : 4;
	word yr : 7;
};

struct dos_t
{
	word ss : 5;
	word mm : 6;
	word hh : 5;
};

void main(int argc, char **argv)
{

	int h;
	word dd, dt;
	dword ut;
	char s[20];

	struct date d;
	struct time t;

	struct {
		struct dos_d d;
		struct dos_t t;
	} dos;

	getdate(&d);
	gettime(&t);
	
	dos.d.da = d.da_day;
	dos.d.mo = d.da_mon;
	dos.d.yr = d.da_year - 1980;

	dos.t.ss = t.ti_sec/2;
	dos.t.mm = t.ti_min;
	dos.t.hh = t.ti_hour;

	if (-1 == (h = open(argv[1], O_RDWR|O_BINARY, ACCFILE))) {
		perror(argv[1]);
		return;
	}

	lseek(h, 0xb0, SEEK_SET);
//  write(h, &dos, sizeof(dos));
//  close(h);
//  exit(1);
	
	read(h, &dd, 2L);
	read(h, &dt, 2L);

	ut = fdate_to_unix(&dt, &dd);
	unix_to_ftscdate(ut, s);

	printf("1st: %s\n", s);

	read(h, &dd, 2L);
	read(h, &dt, 2L);

	ut = fdate_to_unix(&dt, &dd);
	unix_to_ftscdate(ut, s);

	printf("2nd: %s\n", s);
	
	close(h);

	
	return;
}

/****************************/
void unix_to_ftscdate(time_t t, char *s)
{
	struct tm *tm;
	
	tm = localtime(&t);
	
	sprintf(s, "%02u %s %02u  %02u:%02u:%02u", tm->tm_mday, Months[tm->tm_mon].name, tm->tm_year%100, tm->tm_hour, tm->tm_min, tm->tm_sec);
	
	return;
}


/******************************************/
dword fdate_to_unix(word *ftime, word *fdate)
{
	struct date d;
	struct time t;
	
	t.ti_hour = ((struct dos_t *)ftime)->hh;
	t.ti_min  = ((struct dos_t *)ftime)->mm;
	t.ti_sec  = ((struct dos_t *)ftime)->ss * 2;
	t.ti_hund = 0;
	
	d.da_year = ((struct dos_d *)fdate)->yr + 1980;
	d.da_day  = ((struct dos_d *)fdate)->da;
	d.da_mon  = ((struct dos_d *)fdate)->mo;

	return dostounix(&d, &t);
	
}
/*
void unix_to_fdate(dword *ut, word *ftime, word *fdate)
{
	struct date d;
	struct time t;
	
	
	return;
	}
*/
