
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

extern char *xstrcpy(char *i);

char *strUpper(char *str)
{
   char *temp = str;
   
   while(*str != 0) {
      *str = (char)toupper(*str);
      str++;
   }
   return temp;
}

char *strLower(char *str)
{
   char *temp = str;
   
   while(*str != 0) {
      *str = (char)tolower(*str);
      str++;
   }
   return temp;
}

char *stristr(char *str1, char *str2) {
    char *s1, *s2, *p;
    int i;
    
    s1 = xstrcpy(str1);
    s2 = xstrcpy(str2);
    
    strLower(s1);
    strLower(s2);
    
    p = strstr(s1, s2);
    
    if (p) {
	i = p-s1;
	free(s1);
	free(s2);
	return str1+i;
    }
    
    free(s1);
    free(s2);
    return NULL;
}

#ifdef UNIX
char *strrev(char *str)
{
    char *buf;
    int b, e;
    
    if (str == NULL) return NULL;
    e = strlen(str);
    
    buf = (char*)calloc(e+1, sizeof(char));
    
    for (b = 0; e > 0; b++, e--) {
	buf[b] = str[e];
    }
    
    strcpy(str, buf);
    
    free(buf);
    
    return str;
}
#endif
