
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_AddLine)
{

    dXSARGS;
    STRLEN n_a;	
    char err[128], buf[256], *str, *clineno;
    int lineNo = 1;
    TEXT *text = NULL;
	
    if (!items) {
	fprintf(stderr, "%s argument count (need 1 or 2, exist %d\n", err, (int)items);
	abort();
    }
	
    if ( !CurMsg.n ) {
	sprintf(buf, "%s no active message in memory\n", err);
	writeToLog(3, buf);
	XSRETURN_UNDEF;
    }

    sp_s = FromSP(0);
    str = XCAL;
    strcpy(str, sp_s);

    if (items > 1) {
	sp_s = FromSP(1);
	clineno = XCAL;
	strcpy(clineno, sp_s);
	if ( !__isnumber(clineno) ) {
	    fprintf(stderr, "\7%s incorrect lineNo: `%s'\n",  err, clineno );
	    abort();
	}
	lineNo = atoi(clineno);
	free(clineno);
    }
	
	
    if (str[strlen(str)-1] == '.')
	text = get_array_string (str);         /* stem */
    else {
	text = line_to_txt (str);
    }
	
    (void) add_text(&TextFirst, text, lineNo, Mode_Text);
	
    free_text(text);
    free(str);
	
    ftn.stat |= i_Changed;

    XSRETURN_UNDEF;	
}

/* call: addLine( string, [lineNo] ) (default - 1st) */
TEXT * line_to_txt (char *p)
{
	int len;
	TEXT *text, *First = NULL, *Last = NULL;
		
	do {
			
		text = (TEXT *) calloc(1, sizeof(TEXT));
		text->next = NULL;
		len = strlen (p);

		if (len > 254)
			len = 254;

		strncpy (text->str, p, len);
		text->str[len] = '\0';

		p += len;
		
		if (len < 254 || *p == '\0') {
			strcat (text->str, "\r");
		}

		
		if (Last)
			Last->next = text;
		else
			First = text;
		Last = text;

	} while (*p);
	
	return First;
}
