
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_CreateFile)
{
    dXSARGS;
    STRLEN n_a;
    char *err="perl_Createfile()";
    char buf[256], fspec[256], *s, *sp_s, save_str[256], arg1[256];
    BOOL rc = Ok;
    struct FilesTags *FilesTag = NULL;
    int h;
	
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }
	
    sp_s = FromSP(0);
    s = XCAL;
    strcpy(s, sp_s);
    strip( s );
    expand_str(s);
	
    sprintf(buf, "CreateFile: blockname or filespecs to create after all expansions: `%s'\n" , s );
    writeToLog(4, buf);
	
    strcpy(save_str, s);
	
    get_next_word(s, arg1);
	
	/* direct data definition */
    if ( !strnicmp( "@files" , arg1 , strlen(arg1))) { 
		
	writeToLog(4, "createfile: got filespec directly: `%s'\n", s);
		
	if (!strlen(s)) {
	    fprintf(stderr, "%s syntax: `%s'\n", err , save_str );
	    abort();
	}
		
	
	while (get_next_word(s, fspec)) {
		h = sopen (fspec, O_CREAT|O_TRUNC|O_RDWR, SH_DENYNO, ACCFILE);
	    if (h == -1) {
		writeToLog(2, "CreateFile: error creating  file `%s'\n", fspec);
		rc = Fail;
	    } else {
		close(h);
		writeToLog(2, "CreatelFile: file `%s' created OK\n", fspec);
	    }
	}
		
    } /* end of direct data */
	
	
    /* block data */
    else {
	for( FilesTag = FilesTagFirst; FilesTag; FilesTag = FilesTag->next ) {
	    if (!stricmp(save_str, FilesTag->tag)) {
		break;
	    }
	}

	if (NULL == FilesTag) {
	    fprintf(stderr, "create_file: no such <Data Files> : `%s'\n", save_str);
	    abort();
	}
	
	FilesTag->rec = FilesTag->recfirst;
	for(; FilesTag->rec; FilesTag->rec = FilesTag->rec->next ) {
	    FilesTag->rec->file = FilesTag->rec->filefirst;
	    for( ; FilesTag->rec->file; FilesTag->rec->file = FilesTag->rec->file->next ) {
		/* create only non-inverted filenames */
		if (*FilesTag->rec->file->fname != '!') {
		    strcpy(fspec, FilesTag->rec->file->fname);
		    expand_str(fspec);
		    h = sopen (fspec, O_RDWR, SH_DENYNO, ACCFILE);
		    if (h == -1) {
			writeToLog(2, "CreateFile: error creating  file `%s'\n",
					FilesTag->rec->file->fname);
			rc = Fail;
		    } else {
			close(h);
			sprintf(buf, "CreateFile: file `%s' created OK\n", fspec);
			writeToLog(2, buf);
		    }
		}
	    }
	}

    } /* block data */

    free(s);				
	
    XSRETURN_IV(rc);
}

