
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_GetCRC)
{
    dXSARGS;
	char fname[256];
	char *err="perl_GetCRC()";
	ULONG crc = 0L;
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
    if ( CurMsg.n ) {
	if (CurMsg.type == FIDO) {
	    sprintf(fname , "%s%s", CurMsg.areapath,
		    CurMsg.fido.fnames[CurMsg.fido.n-1].fname);
	    crc = crc32( fname );
	} else {
	    TEXT *txt;
	    for( txt = TextFirst; txt; txt = txt->next )
		crc = crc_str(crc, txt->str, strlen(txt->str));
	}
	
    } else {
	writeToLog(3, "getCRC: no active message in memory");
    }

    XSRETURN_IV(crc);
}
