
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_GetKludges)
{
#define BLEN 1024
    dXSARGS;
    int count, kl;
    char tmp_buf[256], buf[BLEN]={0}, *p;
    char **prekl, *err="perl_GetKludges()";
    TEXT *txt;
    BOOL kludge = No, long_kludge = No;
	
    
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
    if ( !CurMsg.n ) {
	sprintf(buf, "%s no active message in memory\n", err);
	writeToLog(3, buf);
	XSRETURN_UNDEF;
    }
/*///////////////////////////////////////////////////////////////////////*/

    prekl = NULL;
																			/* Initialize data area       */
    for(count = 0, txt = TextFirst; txt; txt = txt->next) {
	strcpy( tmp_buf, txt->str);
		
	if ( is_kludge(tmp_buf) || Yes == long_kludge) {
			
	    if (!strncat_max(buf, tmp_buf, BLEN-1)) {
		kludge = Yes;
	    } else {
		if (strlen(tmp_buf) == 255 && 
			tmp_buf[strlen(tmp_buf)-1] != '\r' &&
			tmp_buf[strlen(tmp_buf)-1] != '\n' ) {
		    kludge = No;
		    long_kludge= Yes;
		} else {
		    kludge = Yes;
		}
	    }
	} else
	    kludge = No;
		
	if (Yes == kludge) {
	    if (prekl) {
		prekl = (char**)xrealloc(prekl, (count+1)*sizeof(char*));
	    } else {
		prekl = (char**)xmalloc((count+1)*sizeof(char*));
	    }
	    long_kludge = No;
	    p = buf;
	    strip_CRLF(p);
	    if (strncmp(p, "SEEN-BY", 7)) ++p;
	    prekl[count]=(char*)xcalloc(strlen(p)+1, sizeof(char));
	    strcpy(prekl[count], p);
	    memset(buf, 0, BLEN);
	    count++;
	} /* kludge */
		
    } /* text loop */
	
    if (count) {
	EXTEND(SP, count);
    
        for (kl = 0; kl < count; kl++) {
	    ST(kl) = sv_newmortal();
	    sv_setpv((SV*)ST(kl), prekl[kl]);
	    free(prekl[kl]);
	}
	
	free(prekl);
	XSRETURN(kl);
    }																		/* set stem.0 to lines read   */
    XSRETURN_UNDEF;
}

