
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_GetPktHdr)
{
    dXSARGS;
    char *err="perl_GetPktHdr()";
    
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	

    if (CurMsg.type == PKT && CurMsg.pkt.icur != -1) {
	struct tm tm;
	char buf[256];
	
	EXTEND(SP, 9);

	addr_to_str(CurMsg.pkt.from, buf);
        ST(0) = sv_newmortal();
        sv_setpv((SV*)ST(0), buf);
	
	addr_to_str(CurMsg.pkt.to, buf);
        ST(1) = sv_newmortal();
        sv_setpv((SV*)ST(1), buf);
	
	tm.tm_sec  = CurMsg.pkt.pkt_hdr.second;
	tm.tm_min  = CurMsg.pkt.pkt_hdr.minute;
	tm.tm_hour = CurMsg.pkt.pkt_hdr.hour;
	tm.tm_mday = CurMsg.pkt.pkt_hdr.day;
	tm.tm_mon  = CurMsg.pkt.pkt_hdr.month;
	tm.tm_year = CurMsg.pkt.pkt_hdr.year - 1900;
	
	sprintf(buf, "%02u %s %02u  %02u:%02u:%02u", tm.tm_mday, Months[tm.tm_mon].name, tm.tm_year%100, tm.tm_hour, tm.tm_min, tm.tm_sec);
        ST(2) = sv_newmortal();
        sv_setpv((SV*)ST(2), buf);
	
 	sprintf (buf, "%s", CurMsg.pkt.pkt_hdr.password);
        ST(3) = sv_newmortal();
        sv_setpv((SV*)ST(3), buf);
	
	sprintf (buf, "%x", CurMsg.pkt.pkt_hdr.prodCodeH);
        ST(4) = sv_newmortal();
        sv_setpv((SV*)ST(4), buf);
	
	sprintf (buf, "%x", CurMsg.pkt.pkt_hdr.prodCodeL);
        ST(5) = sv_newmortal();
        sv_setpv((SV*)ST(5), buf);

	sprintf (buf, "%x", CurMsg.pkt.pkt_hdr.verMinor);
        ST(6) = sv_newmortal();
        sv_setpv((SV*)ST(6), buf);

	sprintf (buf, "%x", CurMsg.pkt.pkt_hdr.verMajor);
        ST(7) = sv_newmortal();
        sv_setpv((SV*)ST(7), buf);

	sprintf (buf, "%x", (unsigned int)CurMsg.pkt.pkt_hdr.prodData);
        ST(8) = sv_newmortal();
        sv_setpv((SV*)ST(8), buf);
	
	sprintf(buf, CurMsg.pkt.fname);
        ST(9) = sv_newmortal();
        sv_setpv((SV*)ST(9), buf);
	
	XSRETURN(10);

    }

    XSRETURN_UNDEF;    
}
