
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

/* grep ( where , what ) */

static XS(perl_rxSearch)
{
    dXSARGS;
    STRLEN n_a;
    char *target, *source, regbuf[100];
    char *ps, *err="perl_rxSearch()";
    regex_t *preg = NULL;
    BOOL rc;
    int Icase = rxIcase;


    if (items != 2) {
	fprintf(stderr, "%s argument count (need 2, exist %d)\n", err, (int)items);
	abort();
    }

    sp_s = FromSP(0);
    target = XCAL;	
    strncpy(target, sp_s, n_a);
    strip(target);
    expand_str(target);
    remove_quotes(target);

    sp_s = FromSP(1);
    source = XCAL;
    strncpy(source, sp_s, n_a);
    strip(source);
    expand_str(source);
    remove_quotes(source);

    ps = source;

    if (*ps == '~') {
	++ps;
	Icase = REG_ICASE;
    }

    preg = (regex_t *)calloc(1, sizeof(regex_t));
    if (0 != (rc = regcomp (preg, ps, REG_EXTENDED|Icase))) {
	regerror (rc, preg, regbuf, 100);
	fprintf(stderr, "\7%s regular expression syntax : `%s' (%s)", err, ps, regbuf);
	abort();
    }

    rc = (0 == regexec(preg, target, 0, NULL, 0));
    free(preg);
    free(target);
    free(source);

    XSRETURN_IV(rc);
}
