
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_isBusy)
{
/* call: isBusy( bink_area_name, address ) */

    dXSARGS;
    STRLEN n_a;	
    char *areatag, bsy[256], *caddr, *pathBase;
    char *err="perl_isBusy()";
/*    struct find_t ffblk; */
    ADDR addr;
    struct BinkAreas *BinkArea = NULL;
    BOOL rc;
    int outtype;
	
    if (items != 2) {
	fprintf(stderr, "%s argument count (need 2, exist %d)\n", err, (int)items);
	abort();
    }

    sp_s = FromSP(0);	
    areatag = XCAL;
    strncpy(areatag, sp_s, n_a);
    strip(areatag);
    expand_str(areatag);

    sp_s = FromSP(1);
    caddr = XCAL;	
    strncpy(caddr, sp_s, n_a);
    strip(caddr);
    expand_str(caddr);

    if ( !str_to_addr(caddr, &addr) ) {
	fprintf(stderr, "%s incorrect address : `%s'\n", err, caddr);
	abort();
    }


    for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea ->next ) {
	if (!stricmp(areatag, BinkArea->name)) {
	    outtype = BinkArea->type;
	    break;
	}
    }
	
    if (BinkArea == NULL) {
	fprintf(stderr, "%s binkarea undefined: `%s'\n", err, areatag);
	abort();
    }
	
    if (outtype == tBINK) {
	pathBase = addr_to_binkoutbase(addr, BinkArea);
	sprintf( bsy , "%s.bsy" , pathBase );
    } else if (outtype == tAMIGA4D) {
	pathBase = addr_to_amiga4doutbase(addr, BinkArea);
	sprintf( bsy, "%s.bsy" , pathBase );
    } else {
	pathBase = addr_to_brakeoutbase(addr, BinkArea);
	sprintf( bsy , "%s.Busy" , pathBase );
    }
	
    if (!access(bsy, 0)) {
	writeToLog(4, "isBusy: busy flag `%s' found, system busy\n", bsy);
	rc = Ok;
    } else {
	writeToLog(4, "isBusy: busy flag `%s' NOT found, system free\n", bsy);
	rc = Fail;
    }
    
    free(areatag);
    free(caddr);

    XSRETURN_IV(rc);

}

