
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_KillFile)
{
    dXSARGS;
    STRLEN n_a;
    char *err="perl_KillFile";
    char fspec[256], *s, save_str[256], arg1[256];
    BOOL rc = Ok;
    struct FilesTags *FilesTag = NULL;
	
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)", err, (int)items);
	abort();
    }
	
	
    sp_s = FromSP(0);
    s = XCAL;
    strcpy(s, sp_s);
    strip( s );
    expand_str(s);
	
    writeToLog(4, "kill_file: blockname or filespecs to kill after all expansions: `%s'\n" , s );
	
    strcpy(save_str, s);
	
    get_next_word(s, arg1);
	
	/* direct data definition */
    if ( !strnicmp( "@files" , arg1 , strlen(arg1))) { 
		
	writeToLog(4, "kill_file: got filespec directly: `%s'\n", s);
		
	if (!strlen(s)) {
	    fprintf(stderr, "%s syntax: `%s'\n", err, save_str );
	    abort();
	}
		
	
	while (get_next_word(s, fspec)) {
	    if (0 != remove(fspec)) {
		writeToLog(2, "kill_file: error deleting  file `%s'\n", fspec);
		rc = Fail;
	    } else  {
		writeToLog(2, "kill_file: file `%s' deleted Ok\n", fspec);
	    }
	}
		
    } /* end of direct data */
	
	
	/* block data */
    else {
		
	for( FilesTag = FilesTagFirst; FilesTag; FilesTag = FilesTag->next ) {
	    if (!stricmp(save_str, FilesTag->tag)) {
		break;
	    }
	}

	if (NULL == FilesTag) {
	    fprintf(stderr, "kill_file error:  no such <Data Files> : `%s'\n", save_str);
	    abort();
	}
	
	FilesTag->rec = FilesTag->recfirst;
	for(; FilesTag->rec; FilesTag->rec = FilesTag->rec->next ) {
	    FilesTag->rec->file = FilesTag->rec->filefirst;
	    for( ; FilesTag->rec->file; FilesTag->rec->file = FilesTag->rec->file->next ) {
		/* kill only non-inverted filenames */
		if (*FilesTag->rec->file->fname != '!') {
		    strcpy(fspec, FilesTag->rec->file->fname);
		    expand_str(fspec);
		    if (0 != remove(fspec)) {
			writeToLog(2, "kill_file: error deleting  file `%s'\n",
				    fspec);
			rc = Fail;
		    } else  {
			writeToLog(2, "kill_file: file `%s' deleted Ok\n",
				    fspec);
		    }
		}
	    }
	}

    } /* block data */

    free(s);				

    XSRETURN_IV(rc);	

}
