
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_RouteTo)
{
    dXSARGS;
    STRLEN n_a;
    char *caddr, system[20];
    char *err="perl_RouteTo()";
	
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }

    /* parse arguments */

    sp_s = FromSP(0);
    caddr = XCAL;
    strncpy(caddr, sp_s, n_a);
    expand_str( caddr );
    strip(caddr);

    ftn.routeTo = set_route_to (caddr, err);
	
    areaname_to_system(CurMsg.areaname, system);
	
    if (isZaloop(ViaTextFirst, ftn.routeTo, system)) ftn.stat |= i_ZaLoop;
    else ftn.stat &= ~i_ZaLoop;

    ftn.stat |= i_Changed;

    free(caddr);
    
    XSRETURN_UNDEF;	
	
}

static ADDR set_route_to (char *caddr, char *err)
{
	BOOL found = No;
	ADDR addr;
	struct AddrTags *AddrTag = NULL;
	
	if (!str_to_addr(caddr, &addr)) {
		
		for( AddrTag = AddrTagFirst; AddrTag; AddrTag = AddrTag->next )
		{
			if (!stricmp(caddr, AddrTag->tag)) {
				found = Yes;
				break;
			}
		}

		if (!found) {

			fprintf(stderr, "%s no such <Data Address> : `%s'\n", err, caddr);
			abort();

		}

		AddrTag->rec = AddrTag->recfirst;
		addr = AddrTag->rec->addr;

	} /* block search */

  return addr;
	
}
