
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_SetFlavor)
{
    dXSARGS;
    STRLEN n_a;
    char *err="perl_SetFlavor";
    char cflav[10], *p, s[256], *str;
    word flavor = 0;
    BOOL setClear = No, found = No;
    int i;
	
    if (items != 1) {
	fprintf(stderr, "\7%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }

    if (items) {
	sp_s = FromSP(0);	
	str = XCAL;
	strcpy(str, sp_s);
	strip(str);
	expand_str(str);
	
	sprintf(s, str);
	
	while(get_next_word(s, cflav)) {
	    p = cflav;
	    if ( *p == '!' ) {
		setClear = attrClear;
		p++;
	    } else {
		setClear = attrSet;
	    }

	    flavor = 0;
	    for( i = 0; strlen( Flavors[i].s ); ++i) {
		if ( !stricmp(Flavors[i].s, p) ) {
		    flavor = Flavors[i].n;
		    break;
		}
	    }

	    if (!flavor) {
		fprintf(stderr, "%s unknown flavor: `%s'\n", err, p);
		abort();
	    }

	    if (setClear == attrSet) {
		ftn.flavor |= flavor;
	    } else {
		ftn.flavor &= (word) ~flavor;
	    }
	}
    }   /* argc == 1 */
	
    else {
	ftn.flavor = set_msg_flavor(ftn.attr, ftn.flag);
    }
	
    found = No;
    memset(&s, 0, 256);
    for( i = 0; strlen( Flavors[i].s ); ++i) {
	if ( Flavors[i].n & ftn.flavor ) {
	    if (found) {
		strcat( s , " " );
	    }
	    strcat( s , strUpper(Flavors[i].s) );
	    found = Yes;
	}
    }


    log_msg_hdr();

    writeToLog(1, "   Changed Flavour to %s\n", s);
    
    free(str);

    XSRETURN_UNDEF;
}

