

static XS(perl_RecodeIn)
{
    dXSARGS;
    TEXT* tmp;
    char *err="perl_RecodeIn";
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
    
    if (intabName) {
    
	recodeToInternalCharset(ftn.fromName);
	recodeToInternalCharset(ftn.toName);
	recodeToInternalCharset(ftn.subject);
    
	for ( tmp = TextFirst; tmp; tmp = tmp->next) {
/*	    if (!is_kludge(tmp->str)) { */
		recodeToInternalCharset(tmp->str);
	}
    }
    XSRETURN_UNDEF;
}


static XS(perl_RecodeOut)
{
    dXSARGS;
    TEXT* tmp;
    char *err="perl_RecodeOut";
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
    
    if (outtabName) {
    
	recodeToTransportCharset(ftn.fromName);
	recodeToTransportCharset(ftn.toName);
	recodeToTransportCharset(ftn.subject);
    
	for ( tmp = TextFirst; tmp; tmp = tmp->next) {
/*	    if (!is_kludge(tmp->str)) { */
		recodeToTransportCharset(tmp->str);
	}
    }
    XSRETURN_UNDEF;
}
