
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


/* WriteString (Filename, [string[.]]) */
static XS(perl_WriteString)
{
    dXSARGS;
    STRLEN n_a;
    char *err = "perl_WriteString()";
    char *string = NULL;
    char *fname = NULL, *ps, *s = NULL, *save_str = NULL, *arg1 = NULL;
/*    int i; */
    FILE *h;
    BOOL add_lf = Yes;
    struct FilesTags *FilesTag = NULL;

    if (items < 1 || items > 2) {
	fprintf(stderr, "\7%s argument count(need 1 or 2, exist %d)\n", err, (int)items);
	abort();
    }
	
    items = (items<2) ? items : 2;

    sp_s = FromSP(0);
    s = XCAL;	
    strncpy(s, sp_s, n_a);
    strip(s);
    expand_str_200 (&s);

    ps = s;
	
    if (items > 1) {
	sp_s = FromSP(1);
	string = XCAL;
	strncpy(string, sp_s, n_a);
	strip(string);
	remove_quotes(string);
	expand_str_200(&string);
    }
	

    save_str = (char *) malloc (strlen(s)+1);
    strcpy(save_str, s);
	
    arg1 = (char *) malloc (strlen(s)+1);
    get_next_word(s, arg1);
	
	
	/* direct data definition */
    if ( !strnicmp( "@files" , arg1 , strlen(arg1))) { 
		
    	if (!strlen(s)) {
	    fprintf(stderr, "%s syntax: `%s'\n", err , save_str);
	    abort();
	}
		
	fname = s;
		
    } /* end of direct data */
	
    /* block data */
     else {
		
	for( FilesTag = FilesTagFirst; FilesTag; FilesTag = FilesTag->next ) {
	    if (!stricmp(save_str, FilesTag->tag)) {
		break;
	    }
	}

	if (NULL == FilesTag) {
	    fprintf(stderr, "select, no such <Data Files> : `%s'\n", save_str);
	    abort();
	}
	
	fname = FilesTag->recfirst->filefirst->fname;
    }
	
    if (fname) {
	if ( (h = fopen(fname, "a+b") ) == NULL ) {
	    perror(fname);
	    fprintf(stderr, "%s can`t open file `%s'\n", err, fname );
	    abort();
	}

	if (string == NULL)
#ifndef UNIX
	    fprintf (h, "\r\n");
#else
	    fprintf (h, "\n");
#endif
        else if (!strlen(string) || *string == '.' ||
	     string[strlen(string)-1] != '.') {
			
	    if (strlen(string) && string[strlen(string)-1] == '\\') {
		string[strlen(string)-1] = '\0';
		add_lf = No;
	    }
	    if (add_lf == Yes) {
#ifndef UNIX
		string = xstrcat(string, "\r\n");
#else
		string = xstrcat(string, "\n");
#endif
	    }
	    fputs(string, h);
	} else {
	    TEXT *t = NULL, *t0 = NULL;
	    t = get_array_string (string);         /* stem */
	    while(t) {
		fprintf(h, "%s", t->str);
		if (t->str[strlen(t->str)-1] == '\r')
		    fprintf(h, "\n");
		t0 = t;
		t = t->next;
		free(t0);
	    }
	}
		
	fclose(h);
		
    } /* fname ok */

    free (ps);
    free (arg1);
    free (string);
    free (save_str);

    XSRETURN_UNDEF;	
}
