#ifndef __GENMSGID_H__
#define __GENMSGID_H__

#include <time.h>
#include "compiler.h"
#include "typedefs.h"
#include "ffind.h"

/* Default separator for path specification */

#if defined(SASC) || defined(UNIX)
#define PATH_DELIM  '/'
#else
#define PATH_DELIM  '\\'
#endif

#define eqstr(str1,str2)      (strcmp(str1,str2)==0)
#define eqstri(str1,str2)     (stricmp(str1,str2)==0)
#define eqstrn(str1,str2,n)   (strncmp(str1,str2,n)==0)

int _fast direxist(const char *directory);
dword GenMsgId(char *seqdir, unsigned long max_outrun);
int _createDirectoryTree(const char *pathName);
char *_fast Strip_Trailing(char *str, char strip);
char *_fast Add_Trailing(char *str, char add);

#endif
