
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"


void addtag(int type, char *tag, char *err)
{
	struct Tags *Tag = NULL;
	
	for(Tag = TagFirst; Tag; Tag = Tag->next)
	{
		if (!stricmp(Tag->tag, tag)) {
			if (Tag->i != type) {
				fprintf(stderr, "\7%s duplicate block name `%s'\n", err, tag);
				writeToLog(0, "%s duplicate block name `%s'\n", err, tag);
				abort();
			}
			else {
				return;
			}
		}
	}
	
	Tag = (struct Tags *)calloc(1, sizeof(struct Tags));
	Tag->next = NULL;
	/*******************/
	strcpy(Tag->tag, tag);
	Tag->i = type;
	/*******************/
	if (TagLast) {
		TagLast->next = Tag;
	}
	else {
		TagFirst = Tag;
	}
	
	TagLast = Tag;

	writeToLog(4, "Tag defined: `%s' (%s)\n", tag, TagDesc[type].s );
	
	return;
}

