
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"


/************************************************************************/
void defAddress(char *tag, char *caddr, char *err_diag)
{
	struct AddrTags *AddrTag = NULL, *mark = NULL;
	ADDR addr;
	char buf[256];

	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) ADDRESS, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	if ( !str_to_Waddr(caddr, &addr) ) {
		sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( AddrTag = AddrTagFirst; AddrTag; AddrTag = AddrTag->next )
	{
		if (!stricmp(tag, AddrTag->tag)) {
			mark = AddrTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		AddrTag = mark;
	}
	else {    /* create new tag */
		AddrTag = (struct AddrTags *)calloc(1, sizeof(struct AddrTags));
		AddrTag->next  = NULL;
		/*//////////////////////*/
		strcpy(AddrTag->tag, tag);
		/*//////////////////////*/
		AddrTag->rec = AddrTag->recfirst = AddrTag->reclast  = NULL;
		
		if (AddrTagLast) {
			AddrTagLast->next = AddrTag;
		}
		else {
			AddrTagFirst = AddrTag;
		}
		
		AddrTagLast = AddrTag;
	}
	
	AddrTag->rec = (struct Address *)calloc(1, sizeof(struct Address));
	AddrTag->rec->next = NULL;
	/*//////////////////////*/
	AddrTag->rec->addr = addr;
	/*//////////////////////*/
	
	if (AddrTag->reclast) {
		AddrTag->reclast->next = AddrTag->rec;
	}
	else {
		AddrTag->recfirst = AddrTag->rec;
	}
	
	AddrTag->reclast = AddrTag->rec;

	
	return;
}
