
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void unix_to_fdate(word *ftime, word *fdate, time_t utime);

void defMacro(char *tag, char *str, char *err_diag)
{
    struct Macro *tmpMacro;    
    char macroname[256], macrotag[256] = {0};
    
    if (!*str) return;

    strcpy(macroname, str);
    
    get_next_word(macroname, macrotag);
    
    if (!strlen(macroname)) {
	fprintf(stderr, "\007%s error in line `%s'\n", err_diag, str);
	writeToLog(0, "%s error in line `%s'\n", err_diag, str);
	abort();
    }
    
    for (tmpMacro = MacroFirst; tmpMacro; tmpMacro = tmpMacro->next) {
	if (!stricmp(tmpMacro->macrotag, macrotag)) {
	    memset(tmpMacro->macroname, '\0', 256);
	    strcpy(tmpMacro->macroname, macroname);
	    return;
	}
    }
    
    tmpMacro = MacroFirst;
    
    if (tmpMacro) {
	while (tmpMacro->next) tmpMacro = tmpMacro->next;
	tmpMacro->next = (struct Macro*)xcalloc(1, sizeof(struct Macro));
	tmpMacro = tmpMacro->next;
	strcpy(tmpMacro->macrotag, macrotag);
	strcpy(tmpMacro->macroname, macroname);
	
    } else {
	tmpMacro = (struct Macro*)xcalloc(1, sizeof(struct Macro));
	strcpy(tmpMacro->macrotag, macrotag);
	strcpy(tmpMacro->macroname, macroname);
	MacroFirst = tmpMacro;
    }
    
    return;
}
