
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

LONG   EXPENTRY EXPORT
DefReName(PSZ name, LONG argc, PRXSTRING argv, PSZ queue, PRXSTRING  retstr )
{
// DATA RENAME
//                          1        2            3         4           5
// call: FtnDefReName( "Tag" , "Address1" , "Name1" , "Address2" , "Name2 )
	
	char *res = "";
	char addr[64], tag[20];
	struct ReNameTags *mark = NULL;
	char name1[36], name2[36];
	ADDR Addr1, Addr2;
	int rec = 0;
	
	queue = queue;

	if (argc != 3) {
		printf("\7incorrect number of arguments in a call to %s",name);
		exit(1);
	}
	
		if (!RXSTRPTR(argv[i])) {
			sprintf(buf, "%s argument invalid or missing\n", err);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
		expand_str( buf );
	
	strncpy(tag, RxSTRPTR(argv[0]), 19); tag[19] = 0;
	if ( !strlen(tag) ) {
		printf("\7incorrect tag in a call to %s", name);
		exit(1);
	}
///////////////////////
	addtag(RENAME, tag);  // add tag to the global taglist
///////////////////////
	
	////////////////////////////////////////////
	strncpy(addr, RxSTRPTR(argv[1]), 63); addr[63] = 0;
	if ( !str_to_Waddr(addr,&Addr1) ) {
		printf("\7incorrect address `%s' in a call to %s", addr, name);
		exit(1);
	}
	
	strncpy(name1, RxSTRPTR(argv[2]), 35); addr[35] = 0;
	if ( !strlen(name1) ) {
		printf("\7incorrect tag in a call to %s", name);
		exit(1);
	}
	
	strncpy(addr, RxSTRPTR(argv[3]), 63); addr[63] = 0;
	if ( !str_to_Waddr(addr,&Addr2) ) {
		printf("\7incorrect address `%s' in a call to %s", addr, name);
		exit(1);
	}
	
	strncpy(name2, RxSTRPTR(argv[4]), 35); addr[35] = 0;
	if ( !strlen(name2) ) {
		printf("\7incorrect tag in a call to %s", name);
		exit(1);
	}
	
///////////////////////////////////////////////////////////////////////////
	
	if (ReNameTagFirst) {
		ReNameTag = ReNameTagFirst;
		do {
			if (!stricmp(tag, ReNameTag->tag)) {
				if (ReNameTag->n > 2) {
					printf("Extra record for DATA RENAME %s\n", toupper(tag));
					printf("(only two are allowed)\n");
					exit(1);
				}
				mark = ReNameTag;
				break;
			}
			ReNameTag = ReNameTag->next;
		} while (ReNameTag);
	}

	if (mark) // tag already defined
		ReNameTag = mark;
	else {    // create new tag
		ReNameTag = (struct ReNameTags *)calloc(1, sizeof(struct ReNameTags));
		ReNameTag->next  = NULL;
		////////////////////////////
		strcpy(ReNameTag->tag, tag);
		////////////////////////////
		ReNameTag->rec  = NULL;
		ReNameTag->recfirst = NULL;
		ReNameTag->reclast  = NULL;
		if (ReNameTagLast)
			ReNameTagLast->next = ReNameTag;
		else
			ReNameTagFirst = ReNameTag;
		ReNameTagLast = ReNameTag;
	}
	++ReNameTag->n;
	
	ReNameTag->rec = (struct ReName *)calloc(1, sizeof(struct ReName));
	ReNameTag->rec->next = NULL;
	//////////////////////////////
	ReNameTag->rec->addr1 = Addr1;
	ReNameTag->rec->name1 = name1;
	ReNameTag->rec->addr2 = Addr2;
	ReNameTag->rec->name2 = name2;
	//////////////////////////////
	if (ReNameTag->reclast)
		ReNameTag->reclast->next = ReNameTag->rec;
	else
		ReNameTag->recfirst = ReNameTag->rec;
	ReNameTag->reclast = ReNameTag->rec;
	
	
	strcpy(RXSTRPTR(*retstr), res);  

	retstr->strlength = strlen(res); 

	return 0;                        
}
