#include "squish.h"


BOOL gotoFrame(int h, dword a_off);
BOOL read_SQHDR(int h, SQHDR *sqhdr, dword off);
BOOL write_SQHDR(int h, SQHDR *sqhdr, dword off);

BOOL validate_SQHDR(SQHDR sqhdr, int type, dword off);
BOOL validate_SQIDX(SQIDX sqidx);

int main(int argc, char **argv)
{

	int sqd, sqi; // sqd, sqi handles
	char sqd_name[256]={0};

	sprintf( sqd_name , "%s.sqd" , argv[1] );
	
	printf("about to open squish base `%s'\n", sqd_name);
	
	if( (sqd = open(sqd_name, O_RDWR|O_BINARY, ACCFILE)) == -1 ) {
		perror(sqd_name);
		return 0;
	}

	lseek( sqd , 0L , SEEK_SET );
	
	if (locking(sqd, LK_LOCK, 1L)) {
		printf("error: file already locked\n");
		return 0;
	}
	else {
		printf("file locked OK\n");
	}
	
	getch();
	
	if (locking(sqd, LK_UNLCK, 1L)) {
		printf("unlocking error \n");
	}
	else {
		printf("file unlocked OK\n");
	}
	

	return 1;
}
